<?php

/**
 * Панель управления Estetic Shop Script
 *
 * Осуществляет управление товарами:
 * - добавление;
 * - изменение;
 * - удаление.
 *
 * @author <support@marketscript.ru>
 * @copyright 2011 www.marketscript.ru
 */
 

/**
 * Подключение настроек
 */
 
require_once('../app/config.php');
if(file_exists(MARKET_DATA_PATH . '/var/var.market_email_admin.php'))
	include_once(MARKET_DATA_PATH . '/var/var.market_email_admin.php');
if(file_exists(MARKET_DATA_PATH . '/var/var.market_ga_code.php'))
	include_once(MARKET_DATA_PATH . '/var/var.market_ga_code.php');



/**
 * Локализация
 */

setlocale(LC_ALL, MARKET_LOCALE);



/**
 * Подключение классов и функций
 * для работы с товарами
 */
 
require_once(MARKET_APP_PATH . '/lib/market.php');



/**
 * Подключение классов и функций
 * администратора
 */
 
require_once(MARKET_APP_PATH . '/lib/admin.php');



/**
 * Проверка на наличие настроек биллинга
 * и прав на папки
 */
 
$_INSTALL['chmods']   = checkChmods();
$_INSTALL['billings'] = sizeof(getBillingsConf()) > 0 ? true : false;



/**
 * Определение действия
 */

// По умолчанию - список товаров
$_module = 'list';
$_action = '';


if(isset($_REQUEST['installing'])) {
	
	$_action = 'installing';
}

// Установка скрипта
if(isset($_REQUEST['install'])) {
	
	$_module = 'install';
}

// Добавление или редактирование
if(isset($_REQUEST['add']) || isset($_REQUEST['edit'])) {

	$_module = isset($_REQUEST['add']) ? 'add' : 'edit';
}

// Сохранение
if(isset($_REQUEST['save'])) {

	$_module = 'save';
}

// Удаление товара
if(isset($_REQUEST['delete'])) {

	$_module = 'delete';
	$_id     = $_REQUEST['delete'];
}

// Настройка биллинга
if(isset($_REQUEST['billings'])) {
	
	$_module = 'billings';
}

// Сохранение настроек биллингов
if(isset($_REQUEST['save_billings'])) {
	
	$_module = 'save_billings';
}

// Настройка логина и пароля
if(isset($_REQUEST['password'])) {
	
	$_module = 'password';
}

// Сохранение настроек логина и пароля
if(isset($_REQUEST['save_password'])) {
	
	$_module = 'save_password';
}



/**
 * Установка скрипта
 */
 
if($_module == 'install') {
}



/**
 * Получение списка товаров
 */
 
if($_module == 'list') {

	$items = getItems();
} 



/**
 * Добавление товара
 */
 
if($_module == 'add') {
	
	$item = array(
		'id'         => false,
		'name'       => '',
		'descr'      => '',
		'price'      => '0.00',
		'price_free' => '0',
		'currency'   => '0'
	);
	
	// Список валют					
	$currencies_l  = unserialize(MARKET_CURRENCIES_LABELS);
}



/**
 * Редактирование товара
 */
 
if($_module == 'edit') {

	$_id           = $_REQUEST['edit'];	
	$item          = getItem($_id);
	
	// Список валют					
	$currencies_l  = unserialize(MARKET_CURRENCIES_LABELS);
}



/**
 * Сохранение товара
 */

if($_module == 'save' && isset($_POST)) {

	// Данные о товаре
	$item['id']         = isset($_POST['id'])         ? $_POST['id']         : false;
	$item['name']       = isset($_POST['name'])       ? $_POST['name']       : false;
	$item['hash']       = isset($_POST['hash'])       ? $_POST['hash']       : false;
	$item['file']       = isset($_FILES['file'])      ? $_FILES['file']      : false;
	$item['_file']      = isset($_POST['_file'])      ? $_POST['_file']      : false;
	$item['price']      = isset($_POST['price'])      ? $_POST['price']      : 0.00;
	$item['price_free'] = isset($_POST['price_free']) ? $_POST['price_free'] : 0;
	$item['currency']   = isset($_POST['currency'])   ? $_POST['currency']   : 0;
	$item['descr']      = isset($_POST['descr'])      ? $_POST['descr']      : '';
	$item['image']      = isset($_FILES['image'])     ? $_FILES['image']     : false;
	
	// Сохранение данных
	createItem($item);
	
	// Переход на страницу со списком товаров
	header('Location: ./');
	exit;
}



/**
 * Удаление товара
 */

if($_module == 'delete' && isset($_id)) {

	deleteItem($_id);
	header('Location: ./');
	exit;
}



/**
 * Настройки биллинга
 */
 
if($_module == 'billings') {

	$_BILLING = getBillingsConf();
	
	if(isset($_REQUEST['saved']))
		$_saved = true;
}



/**
 * Сохранение настроек биллинга
 */

if($_module == 'save_billings' && isset($_POST)) {

	// Запись данных
	saveBillings($_POST);
	
	// Переход на страницу со списком товаров
	header('Location: ./?billings&saved' . (isset($_REQUEST['installing']) ? '&installing' : ''));
	exit;
}



/**
 * Настройки логина и пароля
 */
 
if($_module == 'password') {

	$_AUTH = getAuthData();
	
	if(isset($_REQUEST['saved']))
		$_saved = true;
}



/**
 * Сохранение настроек логина и пароля
 */
 
if($_module == 'save_password') {

	saveAuthData($_POST);
	
	// Переход на страницу настроек
	header('Location: ./?password&saved' . (isset($_REQUEST['installing']) ? '&installing' : ''));
	exit;
}


	
/**
 * Вывод данных
 */
  
include_once(MARKET_APP_PATH . '/templates/admin/header.php');
if(file_exists(MARKET_APP_PATH . '/templates/admin/'. $_module .'.php'))
	include_once(MARKET_APP_PATH . '/templates/admin/'. $_module .'.php');
include_once(MARKET_APP_PATH . '/templates/admin/footer.php'); 

?>