<?php

/**
 * Файл настроек MaRKeT Script
 *
 * @author <support@marketscript.ru>
 * @copyright 2011 www.marketscript.ru
 */
 
 
/**
 * Настройки скрипта
 */

// Режим отладки
define('MARKET_DEBUG', false); 

// Сообщения об ошибках
if(MARKET_DEBUG) {	
	ini_set('display_errors', 1);
	error_reporting(E_ALL);	
}

 
// Получение данных о макс. размере
// загружаемых файлов на сервере
$max_upload   = (int)(ini_get('upload_max_filesize'));
$max_post     = (int)(ini_get('post_max_size'));
$memory_limit = (int)(ini_get('memory_limit'));

// Макс размер загружаемого файла (настройки сервера)
define('MARKET_UPLOAD_SIZE',         min($max_upload, $max_post, $memory_limit));



/**
 * Настройки путей и адресов
 */

// Путь до папки со скриптом
define('MARKET_ROOT_PATH',           realpath(dirname(__FILE__ . '../') . '/../') );

// Путь до папки панели управления
define('MARKET_ADMIN_PATH',          MARKET_ROOT_PATH. '/admin' );

// Путь до папки с приложением
define('MARKET_APP_PATH',            MARKET_ROOT_PATH . '/app' );

// Путь до папки с данными
define('MARKET_DATA_PATH',           MARKET_ROOT_PATH . '/data' );

// Путь до папки с товарами
define('MARKET_ITEMS_PATH',          MARKET_DATA_PATH . '/items' );

// Путь до папки с данными товаров
define('MARKET_ITEMS_DATA_PATH',     MARKET_ITEMS_PATH . '/data' );

// Путь до папки с картинками товаров
define('MARKET_ITEMS_IMAGES_PATH',   MARKET_ITEMS_PATH . '/images' );

// Путь до папки с файлами товаров
define('MARKET_ITEMS_FILES_PATH',    MARKET_ITEMS_PATH . '/files' );


// URL папки со скриптом
define('MARKET_ROOT_URL',            str_replace('/index.php', '', str_replace('/admin/index.php', '', $_SERVER['SCRIPT_NAME'])) );

// URL папки панели управления
define('MARKET_ADMIN_URL',           MARKET_ROOT_URL. '/admin' );

// URL папки с приложением
define('MARKET_APP_URL',             MARKET_ROOT_URL. '/app' );

// URL папки с данными
define('MARKET_DATA_URL',            MARKET_ROOT_URL. '/data' );

// Полный URL папки со скриптом
define('MARKET_FULL_URL',            (substr(strtolower($_SERVER["SERVER_PROTOCOL"]), 0, strpos(strtolower($_SERVER["SERVER_PROTOCOL"]), "/")) . (empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "")) . "://" . $_SERVER['SERVER_NAME'] . (($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"])) );




/**
 * Настройка ограничений
 */

// Макс. длина названия
define('MARKET_NAME_MAX_LENGTH',     140 );

// Макс. длина описания
define('MARKET_DESCR_MAX_LENGTH',    1000 );



/**
 * Настройки локации и вывода
 */

// Локализация
define('MARKET_LOCALE',              'ru_RU');

// Валюты
define('MARKET_CURRENCIES',          serialize(array('RUB', 'USD', 'EUR')) );

// Полные названия валют
define('MARKET_CURRENCIES_LABELS',   serialize(array('рублей', 'долларов', 'евро')) );

// Краткие названия валют
define('MARKET_CURRENCIES_LABELS_C', serialize(array('руб.', '$', '&euro;')) );

// Валюта, в которой ведется учет в GA (в настройках аккаунта)
define('MARKET_GA_PRICE',            'RUB' );


// Размеры файла
define('MARKET_FILESIZES_LABELS',    serialize(array(0 => 'Б', 1 => 'кБ', 2 => 'МБ', 3 => 'ГБ', 4 => 'ТБ')) );

// Тема письма из маркета
define('MARKET_MARKET_EMAIL_SUBJECT', 'Новая покупка товара');
	
// Тело письма из маркета
define('MARKET_MARKET_EMAIL_BODY', '<h3>Поздравляем с очередной покупкой!</h3>');
?>
