/**
 * Клиентские скрипты
 * для панели управления MaRKeT Script
 *
 */
 
 

$(document).ready(function() {

	// Кнопки товаров
	itemsButtons(); 
	
	// Форма создания или редактирования товара
	newItemForm();
	
	// Форма настроек управления
	authForm();
	
	// Форма настроек биллингов
	billingForm();
});



/**
 * Функции для кнопок
 * товаров в списке
 */
 
function itemsButtons() {
	
	var delBtns  = $('a.item-action.delete'),
	    codeBtns = $('a.item-action.code'),
	    codeFlds = $('.item-code-field input, .item-code-field textarea');
	
	// Кнопки удаления
	delBtns.click(function(e) {		
		e.preventDefault();
		
		var btn     = $(this),
		    itemRow = btn.parent().parent();
		    
		if(confirm('Подтвердите удаление:')) {
		
			itemRow.hide();			
			$.ajax({ type: 'get', url:  btn.attr('href') });
		}
	});
	
	
	// Кнопки получения кода
	codeBtns.click(function(e) {		
		e.preventDefault();		
		e.stopPropagation();
		
		var btn      = $(this),
		    codeBlc  = btn.next().next().next(),
		    codeBlcs = codeBtns.next().next().next().not(codeBlc);
		    
		codeBlcs.hide();
		codeBlc.fadeIn('fast', function() {
		
			var fFld = codeBlc.find('input')[0];
			
			fFld.focus();
			fFld.select();
		});	
	});	
	
	$('html').click(function() {
	
		var codeBlcs = codeBtns.next().next().next();
		
		codeBlcs.hide();
	});
	
	// Поля с кодом
	codeFlds.click(function(e) {	
		e.preventDefault();		
		e.stopPropagation();
		
		$(this).select();
	});
}



/**
 * Форма создания нового
 * или редактирования
 * товара
 */
 
function newItemForm() {
	
	var form = $('#new-item');
	
	if(form.length > 0) {
	
		var inpsLimit  = $('input.limited-length, textarea.limited-length'),
		    chngFlBtns = $('.item-file-action a.action'),
		    nameInp    = $('#new-item-name'),
		    fileInp    = $('#new-item-file'),
		    _fileInp   = $('#new-item-_file'),
		    priceInp   = $('#new-item-price');

		    
		// Фокус на поле названия
		nameInp.focus();
				
		
		// Счетчики для полей ввода		
		$.each(inpsLimit, function() {
			
			var inp   = $(this),
			    plchl = inp.next(),
			    limit = inp.attr('maxlength');
			
			inp.keydown(function() {				
				plchl.html('Осталось <b>'+ (limit - $(this).val().length) +'</b> из <b>'+ limit +'</b>.');
			});
		});
		
		
		// Поле ввода цены	
		priceInp.blur(function() {
			
			var _this = $(this),
			    _val  = Math.abs(parseFloat(_this.val())).toFixed(2);
			
			_this.val(typeof(_val) != 'NaN' ? _val : '0.00');
		});
		
		
		// Кнопки для смены файла или картинки (при редактировании)		
		chngFlBtns.click(function(e) {
			e.preventDefault();
			
			var btnWrp = $(this).parent();
			
			btnWrp.hide();
			btnWrp.prev().hide();
			btnWrp.next().show();
		});
		
		
		// Проверка формы
		form.submit(function(e) {
		
			// Название			
			if(nameInp.val().length == 0) {
				
				nameInp.focus();
				e.preventDefault();
				return;				
			}			
		
			// Файл			
			if(fileInp.val().length == 0 && _fileInp.length == 0) {
				
				fileInp.focus();
				e.preventDefault();
				return;				
			}			
		
			// Цена			
			if(priceInp.val().length == 0) {
				
				priceInp.focus();
				e.preventDefault();
				return;				
			}	
		});
	}
}



/**
 * Форма настроек управления
 */
 
function authForm() {
	
	var form = $('#auth-config');
	
	if(form.length > 0) {
	
		var login = $('#auth-login'),
		    pass  = $('#auth-pass'),
		    pass2 = $('#auth-pass-2');
		    
		login.focus();
		    
		form.submit(function(e) {
		    
			if(login.val() == '') {
				e.preventDefault();
				alert('Укажите логин');
				login.focus();
				return;
			}			
		    
			if(pass.val() == '') {
				e.preventDefault();
				alert('Укажите пароль');
				pass.focus();
				return;
			}				
		    
			if(pass.val() != pass2.val()) {
				e.preventDefault();
				alert('Пароли должны совпадать');
				pass2.focus();
				return;
			}		
		});
	}
}



/**
 * Форма настроек биллингов
 */
 
function billingForm() {
	
	var form = $('#billings-config');
	
	if(form.length > 0) {
		
		var reqFlds  = form.find('input.required');
		
		$(reqFlds[0]).focus();
		
		form.submit(function(e) {
		
			var stop = false;
			
			$.each(reqFlds, function() {
				
				if(!stop && ($(this).val().length == 0 || !$(this).val())) {
					
					e.preventDefault();
					$(this).focus();
					stop = true;
				}
			});
		});
	}
}