<?php

/**
 * Функции и классы для работы
 * с биллингом «Робокасса».
 *
 * @author <support@marketscript.ru>
 * @copyright 2011 www.marketscript.ru
 */



/**
 * Формирование данных
 * для запроса к биллингу
 */
 
if($_module == 'merchant_bill') {

	// Данные о товаре
	$item = getItem($_item);
	
	// Проверка на свободную цену
	if(isset($_POST['price'])) {
		
		$item['free_price'] = formatPrice($_POST['price']);
		
		if($item['free_price'] < $item['price']) {
		
			header('Location: ' . $_SERVER['HTTP_REFERER']);
			exit;
			
		} else {
		
			$item['price'] = $item['free_price'];
			
			// Если цена 0.00
			if($item['price'] == '0.00') {	
						
				// Получение видов валют
				$currencies = unserialize(MARKET_CURRENCIES);
				
				//Установка id транзакции
				$_BILL['inv_id'] = time();
				
				// Успешная оплата
				successPayment($item, $item['price'], $currencies[$item['currency']], $item['id'], $_BILL);
			
				exit;
			}
		}
		
	}
 
	// Адрес сервера (в тестовом режиме — тестовый сервер)
	$_BILL['server']  = MARKET_DEBUG ? 'http://test.robokassa.ru/Index.aspx' : 'https://merchant.roboxchange.com/Index.aspx';
	
	// Получение видов валют
	$currencies = unserialize(MARKET_CURRENCIES);
	
	// ID транзакции
	$_BILL['inv_id']  = time();
	
	// ID товара
	$_BILL['item_id'] = $item['id'];
	
	if($item != false) {
		
		// Описание товара
		$_BILL['item_descr'] = urlencode(mb_substr($item['name'], 0, 100));
		
		// Стоимость товара (в валюте биллинга)
		$_BILL['item_price'] = convertPrice($item['price'], $currencies[$item['currency']], $_BILL['d_cur']);
		
		// Контрольная сумма
		$_BILL['crc']        = strtolower(md5($_BILL['login'] . ':' . $_BILL['item_price'] . ':' . $_BILL['inv_id'] . ':' . $_BILL['pass1']. ':SHPItemId=' . $_BILL['item_id']));
			
		// Адрес сервера и параметры, а также передача SHPItemId, как пользовательского параметра
		$_BILL['url']        = $_BILL['server'] .  "?MrchLogin=" . $_BILL['login'] . "&" . "OutSum=" . $_BILL['item_price'] . "&" . "InvId=" . $_BILL['inv_id'] . "&" . "Desc=" . $_BILL['item_descr'] . "&" .  "SignatureValue=" . $_BILL['crc'] . "&" . "SHPItemId=" . $_BILL['item_id'];
		 							
		// Отправка запроса на сервер Робокассы
		header('Location: ' . $_BILL['url']);
		exit;
	}
}



/**
 * Обработка ответов биллинга
 */
 
if($_module == 'merchant_return' && $_action != '') {

	// Стоимость покупки
	$_BILL['item_price'] = $_POST["OutSum"];
	
	// Валюта покупки
	$currencies          = unserialize(MARKET_CURRENCIES);
	$currencies_l        = unserialize(MARKET_CURRENCIES_LABELS);
	$currency_index      = array_search($_BILL['item_price'], $currencies);
	$_BILL['item_cur']   = $currencies_l[$currency_index];
	
	
	// ID транзакции
	$_BILL['inv_id']     = $_POST["InvId"];
	
	// Контрольная сумма (возвращаемая)
	$_BILL['crc']        = strtoupper($_POST["SignatureValue"]);
	
	// Контрольная сумма (собственная)
	$_BILL['crc_']       = $_action == 'result' ? strtoupper(md5($_BILL['item_price'] . ':' . $_BILL['inv_id'] . ':' . $_BILL['pass2']. ':SHPItemId=' . $_POST['SHPItemId'])) : strtoupper(md5($_BILL['item_price'] . ':' . $_BILL['inv_id'] . ':' . $_BILL['pass1']. ':SHPItemId=' . $_POST['SHPItemId']));

	
	// Проверка контрольной суммы (если не совпадает)
	if ($_BILL['crc'] != $_BILL['crc_']) {
		
		echo "bad sign\n";
		exit;
	}
	
	// Если контрольная сумма совпадает
	else {		
	
		// Форматирование цены
		$_BILL['item_price'] = formatPrice($_BILL['item_price']);
	
		// Получение ID товара
		$item_id = isset($_POST['SHPItemId']) ? $_POST['SHPItemId'] : false;
			
		// Получение информации о товаре
		$item    = getItem($item_id);
		
		
		/**
		 * Обработка оповещения о платеже
		 * (Result URL)
		 */
		if($_action == 'result') {
			
			// Сообщение для биллинга
			echo 'OK' . $_BILL['inv_id'];
			
			// Установка правильной цены
			$currencies          = unserialize(MARKET_CURRENCIES);
			$currencies_l        = unserialize(MARKET_CURRENCIES_LABELS);
			$_BILL['item_cur']   = $currencies_l[array_search(MARKET_GA_PRICE, $currencies)];
			
			// Отправка уведомления владельцу
			sendMerchantEmail();
			
			exit;			
		}
		
		/**
		 * Успешное проведение платежа
		 * (Success URL)
		 */
		elseif($_action == 'success' && $item) { 
			
			// Получение видов валют
			$currencies = unserialize(MARKET_CURRENCIES);
			
			// Успешая оплата
			successPayment($item, $_BILL['item_price'], $_BILL['d_cur'], $item_id, $_BILL);
			
			exit;			
		}
		
		/**
		 * Неудачное проведение платежа
		 * (Fail URL)
		 */
		elseif($_action == 'fail' && $item) {
			
			// Переход на страницу товара
			header('Location: ./?buy=' . $item_id, true, 301);				
			exit;			
		}
	}
}

exit;
?>
