<?php

/**
 * Функции и классы для работы
 * с биллингом Webmoney.
 *
 * @author <support@marketscript.ru>
 * @copyright 2011 www.marketscript.ru
 */



/**
 * Формирование данных
 * для запроса к биллингу
 */
 
if($_module == 'merchant_bill') {

	// Данные о товаре
	$item = getItem($_item);
	
	// Проверка на свободную цену
	if(isset($_POST['price'])) {
		
		$item['free_price'] = formatPrice($_POST['price']);
		
		if($item['free_price'] < $item['price']) {
		
			header('Location: ' . $_SERVER['HTTP_REFERER']);
			exit;
			
		} else {
		
			$item['price'] = $item['free_price'];
			
			// Если цена 0.00
			if($item['price'] == '0.00') {				
				// Получение видов валют
				$currencies = unserialize(MARKET_CURRENCIES);
				
				// Установка id транзакции
				$_BILL['inv_id']   = time();
				
				// Успешная оплата
				successPayment($item, $item['price'], $currencies[$item['currency']], $item['id'], $_BILL);
				
				exit;
			}
		}
		
	}
 
	// Адрес сервера
	$_BILL['server']       = 'https://merchant.webmoney.ru/lmi/payment.asp';
	$_BILL['LMI_SIM_MODE'] = '0';
		
	// Получение видов валют
	$currencies = unserialize(MARKET_CURRENCIES);
	
	// ID транзакции
	$_BILL['LMI_PAYMENT_NO']  = time();
	
	// ID товара
	$_BILL['item_id'] = $item['id'];
	
	if($item != false) {
	
		// Определение валюты продавца по номеру кошелька
		$purse_cur = strtoupper(substr($_BILL['purse'], 0, 1));
		if('Z' == $purse_cur)
			$_BILL['d_cur'] = 'USD';
		elseif('R' == $purse_cur)
			$_BILL['d_cur'] = 'RUB';
		elseif('E' == $purse_cur)
			$_BILL['d_cur'] = 'EUR';
		else
			$_BILL['d_cur'] = false;
			
		if($_BILL['d_cur']) {
					
			// Описание товара
			$_BILL['LMI_PAYMENT_DESC']   = mb_substr($item['name'], 0, 100);
			
			// Стоимость товара (в валюте биллинга)
			$_BILL['LMI_PAYMENT_AMOUNT'] = convertPrice($item['price'], $currencies[$item['currency']], $_BILL['d_cur']);
			
			// Кошелек продавца
			$_BILL['LMI_PAYEE_PURSE'] = $_BILL['purse'];
			
			// Адрес сервера и параметры
			$_BILL['request_data'] = array(
				'LMI_RESULT_URL'          => MARKET_FULL_URL . MARKET_ROOT_URL . '/?merchant=webmoney&return=result',
				'LMI_SUCCESS_URL'         => MARKET_FULL_URL . MARKET_ROOT_URL . '/?merchant=webmoney&return=success',
				'LMI_FAIL_URL'            => MARKET_FULL_URL . MARKET_ROOT_URL . '/?merchant=webmoney&return=fail',
				
				'LMI_PAYMENT_AMOUNT'      => $_BILL['LMI_PAYMENT_AMOUNT'],
				'LMI_PAYEE_PURSE'         => $_BILL['LMI_PAYEE_PURSE'],
				'LMI_PAYMENT_DESC'        => $_BILL['LMI_PAYMENT_DESC'],
				'LMI_PAYMENT_DESC_BASE64' => base64_encode($_BILL['LMI_PAYMENT_DESC']),
				'LMI_PAYMENT_NO'          => $_BILL['LMI_PAYMENT_NO'],
				'LMI_SIM_MODE'            => $_BILL['LMI_SIM_MODE'],
				'SES_HASH'                => md5($_BILL['LMI_PAYMENT_NO'] . $_BILL['LMI_PAYMENT_AMOUNT'] . $_BILL['LMI_PAYEE_PURSE']),
				'SES_ID'                  => session_id()
			);
			
			// Запоминание товара
			$_SESSION[$_BILL['request_data']['SES_HASH']] = $_BILL['item_id'];
			
			// Форма и отправка POST запроса
			$tpl  = '<html><head><title>Обработка платежа Webmoney…</title></head>';
			$tpl .= '<body';
			$tpl .= ' onload="document.getElementById(\'webmoney-payment\').submit();"';
			$tpl .= '><form id="webmoney-payment" method="post" action="' . $_BILL['server'] . '" style="margin: 100px auto; width: 300px; text-align: center">';
			
			while (list($key, $value) = each($_BILL['request_data']))
				$tpl .= '<input type="hidden" name="' . $key . '" value="' . $value . '" />';
			
			$tpl .= '<script type="text/javascript">document.write(\'Обработка платежа Webmoney…\');</script>';
			$tpl .= '<noscript><input type="submit" name="submit" value="Заплатить ' . displayPrice($item['price'], $item['currency']) . ' с помощью Webmoney" /></noscript></form></body></html>';
			
			echo $tpl;
			exit;
			
		} else
			exit;
	}
}



/**
 * Обработка ответов
 * биллинга Webmoney
 */
 
if($_module == 'merchant_return' && $_action != '') {

	/**
	 * Предварительный запрос
	 */	
	
	if(isset($_POST['LMI_PREREQUEST'])) {
	
		echo 'YES';
		exit;
	}

	else {

		/**
		 * Обработка оповещения о платеже
		 * (Result URL)
		 */
		 
		// Контрольная сумма
		$hash = strtoupper(md5($_REQUEST['LMI_PAYEE_PURSE'] . $_REQUEST['LMI_PAYMENT_AMOUNT'] . $_REQUEST['LMI_PAYMENT_NO'] . $_REQUEST['LMI_MODE'] . $_REQUEST['LMI_SYS_INVS_NO'] . $_REQUEST['LMI_SYS_TRANS_NO'] . $_REQUEST['LMI_SYS_TRANS_DATE'] . $_REQUEST['pass'] . $_REQUEST['LMI_PAYER_PURSE'] . $_REQUEST['LMI_PAYER_WM']));
		 
		if('result' == $_action  && $hash == $_POST['LMI_HASH']) {
			
			// Уведомление биллинга
			echo 'YES';
			
			// Установка правильной цены
			$currencies          = unserialize(MARKET_CURRENCIES);
			$currencies_l        = unserialize(MARKET_CURRENCIES_LABELS);
			$_BILL['item_cur']   = $currencies_l[array_search(MARKET_GA_PRICE, $currencies)];
			
			// Отправка уведомления владельцу
			sendMerchantEmail();
			
			exit;
		}
		 
		else {
				
			// Получение ID товара
			$item_id = isset($_SESSION[$_POST['SES_HASH']]) ? $_SESSION[$_POST['SES_HASH']] : false;
				
			// Получение информации о товаре
			$item    = getItem($item_id);
			
			// Получение ID транзакции
			$_BILL['inv_id'] = $_POST['LMI_PAYMENT_NO'];
			
			
			/**
			 * Успешное проведение платежа
			 * (Success URL)
			 */
			 
			if('success' == $_action && $item) {	
					
				// Установка id транзакции
				$_BILL['inv_id']   = time();
				
				// Успешное оплата
				successPayment($item, $item['price'], $currencies[$item['currency']], $item['id'], $_BILL);
				
				exit;
			}
			
			
			/**
			 * Неудачное проведение платежа
			 * (Fail URL)
			 */
			
			elseif('fail' == $_action && $item) {
				
				// Переход на страницу товара
				header('Location: ./?buy=' . $item_id, true, 301);				
				exit;			
			}
			
			exit;
		}
	}
}

exit;
?>
