<?php

/**
 * MaRKeT Script v1.1.3
 *
 * Скрипт, позволяющий продавать любой цифровой контент:
 * - архивы;
 * - изображения;
 * - текстовые файлы;
 * - аудио файлы;
 * - видео файлы.
 * 
 * Скрипт не требует базы данных, оплата производится
 * через биллинг-агрегатор «Робокасса»,«Webmoney» с помощью:
 * - SMS;
 * - банковские карты (Visa, Visa Electron, Mastercard);
 * - электронные деньги (Яндекс.Деньги, Webmoney);
 * - терминалы оплаты.
 *
 * Так же скрипт может принимать оплату
 * напрямую через Webmoney.
 *
 * @author <support@marketscript.ru>
 * @copyright 2011 www.marketscript.ru
 */
 
 
/**
 * Старт сессии
 */
 
session_start();
 


/**
 * Подключение настроек
 */
 
require_once('./app/config.php');
if(file_exists(MARKET_DATA_PATH . '/var/var.market_email_admin.php'))
	include_once(MARKET_DATA_PATH . '/var/var.market_email_admin.php');



/**
 * Локализация
 */

setlocale(LC_ALL, MARKET_LOCALE);



/**
 * Подключение классов и функций
 */
 
require_once(MARKET_APP_PATH . '/lib/market.php');



/**
 * Просмотр товара
 */
 
$_module = '';

if(isset($_REQUEST['buy'])) {

	$_module = 'buy';
	
	// Данные о товаре
	$_id              = $_REQUEST['buy'];	
	$item             = getItem($_id);
	
	if($item) {	
		$file             = glob(MARKET_ITEMS_FILES_PATH . '/' . $item['id'] . '.*');	
		$item['filesize'] = displayFileSize(filesize($file[0]));					
		$currencies_lc    = unserialize(MARKET_CURRENCIES_LABELS_C);
		
		// Получение кода Google Analytics
		if(file_exists(MARKET_DATA_PATH . '/var/var.market_ga_code.php'))
			include_once(MARKET_DATA_PATH . '/var/var.market_ga_code.php');
			
		// Включение Google Analytics Ecommerce
		$_GA_CODE  = addGAEcommerceCode($item);
		
		// Данные о биллингах
		$_BILLINGS = getBillingsConf();
	}
	
	else
		exit;
}



/**
 * Скачивание товара
 */

if(isset($_REQUEST['download'])) {

	// Данные о товаре
	$_id     = $_REQUEST['download'];	
	$item    = getItem($_id);

	if(isAlreadyBought($item)) {

		$_module = 'download';
		$_hash   = $_REQUEST['hash'];
		
		downloadItem($_id, $_hash);
	}
	
	exit;
}



/**
 * Просмотр картинки товара
 */

if(isset($_REQUEST['image'])) {

	$_module = 'image';
	$_id     = $_REQUEST['image'];	
	$item    = getItem($_id);
	
	if(file_exists($item['image_path']))
		imageThumb($item['image_path'], 200);
		
	exit;
}
 


/**
 * Взаимодействие с биллингом
 */

if(isset($_REQUEST['merchant'])) {

	// Запрос на оплату в биллинг
	if(isset($_REQUEST['bill'])) {

		$_module   = 'merchant_bill';
		$_merchant = $_REQUEST['merchant'];
		$_item     = $_REQUEST['bill'];
	} 
	
	// Ответы от биллинга
	elseif(isset($_REQUEST['return'])) {

		$_module   = 'merchant_return';
		$_action   = $_REQUEST['return'];
		$_merchant = $_REQUEST['merchant'];	
	}
	
	else exit;
	
	// Файл настроек биллинга
	$merchant_conf = MARKET_DATA_PATH . '/config/billings/' . $_merchant . '.php';
	
	// Файл функций биллинга
	$merchant_api  = MARKET_APP_PATH . '/lib/billings/' . $_merchant . '.php';
	
	// Подключение настроек и выполнение функций
	if(file_exists($merchant_conf) && file_exists($merchant_api)) {
	
		include_once($merchant_conf);
		include_once($merchant_api);
	}	
	
	exit;
}



/**
 * Обращение к корню
 */
 
if($_module == '') {
	
	header('Location: ' . MARKET_FULL_URL);
}



/**
 * Вывод данных
 */
 
include_once(MARKET_APP_PATH . '/templates/market/header.php');
if(file_exists(MARKET_APP_PATH . '/templates/market/'. $_module .'.php'))
	include_once(MARKET_APP_PATH . '/templates/market/'. $_module .'.php');
include_once(MARKET_APP_PATH . '/templates/market/footer.php');
exit;
?>